/* -*- Chronus.mq4
 *
 * Copyright (C) 2013, Tener C. Hades
 */
 
/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <tener.hades@gmail.com> wrote this file. As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return. Tener Hades.
 * ----------------------------------------------------------------------------
 */

/****************************************************************************/
/*                                                                          */
/*         +------------------------------------------------------+         */
/*         |                 Chronus by Tener Hades               |         */
/*         +------------------------------------------------------+         */
/*                                                                          */
/*      0.2                                                                 */
/*  ------------                                                            */
/*  plans - i'm gonna put in a trade limitation scheme, be it by type (buy  */
/*          or sell or pending or whatnot), or by quantity (i only want to  */
/*          show my last 3 trades closed and only 1 of my open ones), or    */
/*          any other combination i can think of..                          */
/*        - also, i should give the user quite a bit more control over the  */
/*          colors and styles and line widths and stuff.. scroll down to    */
/*          line 205 and modify ch_drawSymbolsForArray() if you want to     */
/*          mess with this stuff now.                                       */
/*  bugs 1- not my fault: when selecting a different item from the listbox, */
/*          fx1's mt4gui library fails to send a synthetic tick for the     */
/*          user action (click) like it does with buttons and checkboxes.   */
/*       -> solution: use mt4ticker and email fx1 to complain.              */
/*       2- also: even after real (or fake) ticks are processed, the list-  */
/*          box refuses to lose focus until you click something else (i use */
/*          the checkbox that Chronus always creates to force refocusing).  */
/*          reason why this is a bug: if the lisbox has focus, i cannot use */
/*          keyboard buttons to modify my charts (mainly DEL key).          */
/*       -> solution: enable ForceUnfocusListbox and email fx1 to complain  */
/*                                                                          */
/*      0.1                                                                 */
/*  ------------                                                            */
/*  news  - Hello, this is Chronus. Chronus, or "Khronos", was the Proto-   */
/*          genos (primeval god) of time, a divinity who emerged self-      */
/*          formed at the beginning of creation in the Orphic cosmogonies.  */
/*          (http://www.theoi.com/Protogenos/Khronos.html)                  */
/*  fact  - This software doesn't happen to be a god of any sort as it is   */
/*          still very much in beta mode.                                   */
/*  done  - mapping of closed orders. i decided to do it just a tad differ- */
/*          ently than the MT4 way of doing it. solid lines for profitable  */
/*          trades, instead of every trade having dotted lines (read: only  */
/*          non-profit trades are dotted)                                   */
/*  done  - it's now optional to also draw arrows and lines for open trades,*/
/*          though the stoploss/takeprofit level don't get drawn since mt4  */
/*          already makes those huge horizontal lines anyways               */
/*  done  - a pretty little listbox shows up when at least one order in     */
/*          either the history or current trades has a magic number on (on  */
/*          the symbol). i thought about allowing user to specify other     */
/*          magics numbers as well (in the inputs), but i think it would do */
/*          anybody any good as the trades wouldn't be on the screen..      */
/*  fact  - don't worry, if none of your trades have magic numbers (ie. you */
/*          don't use any EA's or use poorly coded EA's), then you'll see   */
/*          no listbox and all trades will be drawn.                        */
/*                                                                          */
/****************************************************************************/

/* -*- Purpose
 *
 * I've decided on the name of Chronus due to there being an overpopulation of OrderHistory scripts on
 * on the Ether already, whose names are "OrderHistory" and the such. Let me clarify: I said "Scripts". This, I
 * feel, happens to be an unforgivable design desicion because at best we must run even the most complete of
 * scripts at least one additional time to make the objects disappear; at worst, however, we need to delete these
 * objects by hand. This is time consuming and frustrating.
 * 
 * I am an algorithmic trader and often run more than one system on a single account. I use trade-tracking tools
 * already without technically _needing_ a code like this, but having something to see how an algorithm acted,
 * or should have acted, is definitaley an appreciated benefit. In the past, I've tried to get a handle on with
 * using some other OrderHistory scripts, but never liked the idea of them being scripts.
 *
 * The account trackers online, such as MyFxBook and, now, ForexFactory's own, are just that: account trackers.
 * What they are not is individual algorithm trackers.
 *
 * I'm looking to solve these issues for myself with the help of Chronus. My design philosiphy, from a usability
 * perspective, is such that software should be simple, convienent and "just work". My goal is to work toward making
 * this code the most simple-to-use OrderHistory indicator for MT4.
 *
 * In conclusion, my goal for Chronus to be a simple and reliable on-chart view of both closed and open orders,
 * with the ability to show all trades, trades with a specific magic number, or trades of a set of magic numbers;
 * and have the ability to quickly cycle through them, or remove itself altogether.
 * 
 * Chronus 0.1 was hacked up in about a day using fx1's mt4gui/mt4gui2 library and was made to be as out of the
 * way, simple, and clear as possible, while looking exactly like MT4's built-in drag'n'drop order view.
 *
 **/


// directives
#property copyright "Tener Hades"
#property link "tener.hades@gmail.com"

#import "user32.dll"
   int GetDC(int hwnd);
   int ReleaseDC(int hwnd,int hdc);
#import "gdi32.dll"
   color GetPixel(int hdc,int x,int y);
#import "mt4gui2.dll"
   int tbPutObject(int,string,int,int,int,int,string);//hwnd,type,x,y,w,h,label
   int tbSetBgColor(int,int,int);
   int tbSetTextColor(int,int,int);
   string tbGetText(int,int);
   int tbSetText(int,int,string,int,string);
   bool tbIsChecked(int,int);
   int tbSetChecked(int,int,int);
   int tbRemove(int,int);
   int tbAddListItem(int,int,string);
   int tbGetListSel(int,int);
   int tbSetListSel(int,int,int);
   int tbEnable(int,int,int); // hwnd, object, 0|1   
#import

#property indicator_chart_window

// flow control/readability constants
#define MODE_INIT    3
#define MODE_DEINIT  2
#define MODE_START   1

#define EXIT_SUCCESS 0
#define EXIT_FAILURE 1

#define PREFIX       "Chronus-"

// options
extern string unshamefulplug  ="Thanks for trying Chronus 0.1";
extern string spacing0        ="------------------------------------";
extern string general         = "General options:";
extern bool DrawOpenTrades    = true;
extern bool ShowStoplosses    = true;
extern bool ShowTakeprofits   = true;
//extern string spacing1        ="------------------------------------";
//extern string drawingcaps1    = "Limit the closed trades drawn:";
//extern int  NumberOfTrades    = 5;
//extern bool OnlyShorts or OnlyLongs
//extern bool some_other_condition
extern string spacing2        ="------------------------------------";
extern string appearence      = "Checkbox appearence options:";
extern string appearence2     = "(set SymbolColor to \'Magenta\' for auto)"; // magenta is such an ugly color. surely nobody will miss it..
extern string Font            = "Wingdings";
extern int    SymbolNum       = 190;
extern color  SymbolColor     = White;
extern int    SymbolSize      = 19;
extern string spacing3        ="------------------------------------";
extern string misc1           ="Miscelaneous options:";
extern bool   ForceUnfocusListbox=false;


// mt4 bypass
int init()  { return (ChronusMain(MODE_INIT));   }
int deinit(){ return (ChronusMain(MODE_DEINIT)); }
int start() { return (ChronusMain(MODE_START));  }
	

// program entry point
int ChronusMain(int mode)
{
	static int hwnd.chart, hwnd.checkbox, hwnd.listbox=0;
	static int tickets.hist[], tickets.open[], magic_numbers[], selected_magic;
	static bool listbox_created=false;
	
	string text;
	
	ch_removeObjectsByArray(tickets.hist);
	ch_removeObjectsByArray(tickets.open);
	
	if (mode==MODE_DEINIT)
		return (ch_destroyObjects(hwnd.chart,hwnd.checkbox,hwnd.listbox));
	
	if (mode==MODE_INIT)
		if (ch_createCheckbox(hwnd.chart,hwnd.checkbox)==EXIT_FAILURE)
			return (EXIT_FAILURE);
	
	if (ch_populateMagicNumbersArray(magic_numbers)>0)
		ch_createListbox(hwnd.chart,hwnd.listbox,magic_numbers);


	ch_setObjectColors(hwnd.chart,hwnd.checkbox);
	ch_setObjectColors(hwnd.chart,hwnd.listbox);

	if (hwnd.listbox>0){
		text=tbGetText(hwnd.chart,hwnd.listbox);
		if      (text=="All Trades")         selected_magic=0;
		else if (text=="Only with Magic")    selected_magic=-1;
		else if (text=="Only without Magic") selected_magic=-2;
		else selected_magic=StrToInteger(text); // gacefully defaults to "All Trades" on failure
		
		if (selected_magic==0)
			tbSetListSel(hwnd.chart,hwnd.listbox,0);
		
		if (ForceUnfocusListbox==true){
			tbEnable(hwnd.chart,hwnd.listbox,0);
			tbEnable(hwnd.chart,hwnd.listbox,1);
		}
	}
	
	if (tbIsChecked(hwnd.chart,hwnd.checkbox)){
		ch_populateArrayByMode(tickets.hist,MODE_HISTORY,selected_magic);
		ch_drawSymbolsForArray(tickets.hist,MODE_HISTORY);
		if (DrawOpenTrades){
			ch_populateArrayByMode(tickets.open,MODE_TRADES,selected_magic);
			ch_drawSymbolsForArray(tickets.open,MODE_TRADES);
		}
	}
	WindowRedraw();
	return (EXIT_SUCCESS);
}

// populate tickets array with ticket numbers of orders to be drawn later. mode is passed to OrderSelect()
int ch_populateArrayByMode(int &tickets[], int mode, int magic)
{
	int total,i;
	
	total=OrdersHistoryTotal();
	if (mode==MODE_TRADES)
		total=OrdersTotal();
	for (i=0;i<total;i++){
		if (!OrderSelect(i,SELECT_BY_POS,mode)){
			Print("ch_populateArrayByMode(): failed. position: "+i+"; mode: "+mode+"; error #"+GetLastError());
			return (EXIT_FAILURE);
		}
		if (OrderSymbol()!=Symbol()) continue;
		if (OrderType()>=2) continue;
		switch(magic){
			case  0: break;
			case -1: if (OrderMagicNumber()<=0) continue; break;
			case -2: if (OrderMagicNumber()>0) continue; break;
			default: if (OrderMagicNumber()!=magic) continue; break;
		}
		ArrayResize(tickets,ArraySize(tickets)+1);
		tickets[ArraySize(tickets)-1]=OrderTicket();
	}
	return (EXIT_SUCCESS);
}

// search for magic numbers to fill the listbox with
int ch_populateMagicNumbersArray(int &magic_numbers[])
{
	int total,i;
	int temparray[];
	
	ArrayResize(temparray,0);
	ArrayResize(magic_numbers,0);
	
	// search historical trades
	for (i=0,total=OrdersHistoryTotal();i<total;i++){
		if (!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
			Print("ch_populateMagicNumbersArray(): failed. E:"+GetLastError());
			return (EXIT_FAILURE);
		}
		if (OrderMagicNumber()<=0) continue;
		if (OrderSymbol()!=Symbol()) continue;
		ArrayResize(temparray,ArraySize(temparray)+1);
		temparray[ArraySize(temparray)-1]=OrderMagicNumber();
	}
	
	// search active trades
	for (i=0,total=OrdersTotal();i<total;i++){
		if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
			Print("ch_populateMagicNumbersArray(): failed. E:"+GetLastError());
			return (EXIT_FAILURE);
		}
		if (OrderMagicNumber()<=0) continue;
		if (OrderSymbol()!=Symbol()) continue;
		ArrayResize(temparray,ArraySize(temparray)+1);
		temparray[ArraySize(temparray)-1]=OrderMagicNumber();
	}
	
	// remove duplicates
	if (ArraySize(temparray)>0)
		ArraySort(temparray);
	for (i=0,total=ArraySize(temparray);i<total;i++){
		if (temparray[i]==temparray[i+1]) continue;
		ArrayResize(magic_numbers,ArraySize(magic_numbers)+1);
		magic_numbers[ArraySize(magic_numbers)-1]=temparray[i];
	}
	
	// done
	return (ArraySize(magic_numbers));
}

// draw all objects requested for each element in the tickets array
int ch_drawSymbolsForArray(int tickets[], int mode)
{
	int i;
	color col;
	
	for (i=0; i<ArraySize(tickets); i++){
		if (!OrderSelect(tickets[i],SELECT_BY_TICKET,mode)){
			Print("ch_drawSymbolsForArray(): failed. ticket "+tickets[i]+"; mode: "+mode+"; error #"+GetLastError());
			return (EXIT_FAILURE);
		}
		if (OrderType()==OP_BUY) col=Blue; else col=Red;
		ch_drawArrow(PREFIX+tickets[i]+"_open",1,OrderOpenTime(),OrderOpenPrice(),col);
		if (OrderCloseTime()>0){
			ch_drawArrow(PREFIX+tickets[i]+"_close",3,OrderCloseTime(),OrderClosePrice(),Goldenrod);
			if (ShowStoplosses)  ch_drawArrow(PREFIX+tickets[i]+"_stop",4,OrderOpenTime(),OrderStopLoss(),Red);
			if (ShowTakeprofits) ch_drawArrow(PREFIX+tickets[i]+"_take",4,OrderOpenTime(),OrderTakeProfit(),Blue);
			if (OrderProfit()>0.0)
				ch_drawTrend(PREFIX+tickets[i]+"_line",OrderOpenTime(),OrderOpenPrice(),OrderCloseTime(),OrderClosePrice(),STYLE_SOLID,1,col);
			else
				ch_drawTrend(PREFIX+tickets[i]+"_line",OrderOpenTime(),OrderOpenPrice(),OrderCloseTime(),OrderClosePrice(),STYLE_DOT,1,col);
		}
		else {
			if (OrderProfit()>0.0)
				ch_drawTrend(PREFIX+tickets[i]+"_line",OrderOpenTime(),OrderOpenPrice(),TimeCurrent(),OrderClosePrice(),STYLE_SOLID,1,White);
			else
				ch_drawTrend(PREFIX+tickets[i]+"_line",OrderOpenTime(),OrderOpenPrice(),TimeCurrent(),OrderClosePrice(),STYLE_DOT,1,White);
		}
	}
}

// create arrow object
void ch_drawArrow(string name, int arrowcode, datetime time1, double price1, color col)
{
	ObjectCreate(name,OBJ_ARROW,0,0,0);
	ObjectSet(name,OBJPROP_ARROWCODE,arrowcode);
	ObjectSet(name,OBJPROP_TIME1,time1);
	ObjectSet(name,OBJPROP_PRICE1,price1);
	ObjectSet(name,OBJPROP_COLOR,col);
}

// create trendline object
void ch_drawTrend(string name, datetime time1, double price1, datetime time2, double price2, double style, double width, color col)
{
	ObjectCreate(name,OBJ_TREND,0,0,0);
	ObjectSet(name,OBJPROP_STYLE,style);
	ObjectSet(name,OBJPROP_WIDTH,width);
	ObjectSet(name,OBJPROP_TIME1,time1);
	ObjectSet(name,OBJPROP_PRICE1,price1);
	ObjectSet(name,OBJPROP_TIME2,time2);
	ObjectSet(name,OBJPROP_PRICE2,price2);
	ObjectSet(name,OBJPROP_COLOR,col);
	ObjectSet(name,OBJPROP_RAY,0);
}

// delete objects on the chart based on ticket number and empty the array
void ch_removeObjectsByArray(int &tickets[])
{
	int i;
	for (i=0; i<ArraySize(tickets);i++){
		ObjectDelete(PREFIX+tickets[i]+"_line");
		ObjectDelete(PREFIX+tickets[i]+"_stop");
		ObjectDelete(PREFIX+tickets[i]+"_take");
		ObjectDelete(PREFIX+tickets[i]+"_open");
		ObjectDelete(PREFIX+tickets[i]+"_close");
	}
	ArrayResize(tickets,0);
}

// destroy the objects described by hwnd.*
// if the chart is about to be shown on another timeframe or the indicator is recompiled, indicate that we should preserve the objects' status
int ch_destroyObjects(int hwnd.chart, int hwnd.checkbox, int hwnd.listbox)
{
	string selection;
	int magic;
	
	if (!IsDllsAllowed())
		return (EXIT_FAILURE);
	
	if (UninitializeReason()==REASON_CHARTCHANGE||UninitializeReason()==REASON_RECOMPILE){
		if (tbIsChecked(hwnd.chart,hwnd.checkbox))
			GlobalVariableSet("Chronus-check-box-on-init",1);
		if (hwnd.listbox>0){
			selection=tbGetText(hwnd.chart,hwnd.listbox);
			if (selection=="All Trades")
				GlobalVariableSet("Chronus-list-content-on-init",0);
			else if (selection=="Only with Magic")
				GlobalVariableSet("Chronus-list-content-on-init",-1);
			else if (selection=="Only without Magic")
				GlobalVariableSet("Chronus-list-content-on-init",-2);
			else {
				magic=StrToInteger(selection);
				GlobalVariableSet("Chronus-list-content-on-init",magic);
			}
		}
	}
	tbRemove(hwnd.chart,hwnd.listbox);
	tbRemove(hwnd.chart,hwnd.checkbox);
	return (EXIT_SUCCESS);
}

// set colors for object background and foreground
void ch_setObjectColors(int hwnd.chart, int hwnd.obj)
{
	int hdc;
	color foreground,background;
	
	if (!hwnd.obj>0)
		return;
	
	hdc=GetDC(hwnd.chart);
	background=GetPixel(hdc,1,2);
	
	if (SymbolColor==Magenta)
		foreground=GetPixel(hdc,2,2);
	else
		foreground=SymbolColor;
	ReleaseDC(hwnd.chart,hdc);
	
	tbSetBgColor(hwnd.chart,hwnd.obj,background);
	tbSetTextColor(hwnd.chart,hwnd.obj,foreground);
}

// check for the ability to draw a checkbox and draw it if possible
// store the values needed to destroy it in the arguments that were passed
int ch_createCheckbox(int &hwnd.chart, int &hwnd.checkbox)
{	
	if (!IsDllsAllowed()){
		Print("You must allow DLLs in the indicator properties window and have the fx1 mt4gui library installed to use this indicator!");
		return (EXIT_FAILURE);
	}
	
	hwnd.chart=WindowHandle(Symbol(),Period());
	hwnd.checkbox=tbPutObject(hwnd.chart,"checkbox",-36,5,100,14,"ChronusCheckbox");
	tbSetText(hwnd.chart,hwnd.checkbox,CharToStr(SymbolNum),SymbolSize,Font);
	
	if (GlobalVariableCheck("Chronus-check-box-on-init")==true){
		tbSetChecked(hwnd.chart,hwnd.checkbox,1);
		GlobalVariableDel("Chronus-check-box-on-init");
	}
	return (EXIT_SUCCESS);
}

// function above checks our error condition and sets hwnd.chart for us
// all we have to do is create the listbox, put stuff in it and set it
int ch_createListbox(int hwnd.chart, int &hwnd.listbox, int magics[])
{
	int i;
	double j=0;
	static int magics.save[];
	
	// if the listbox is already created, find out if we need to update the contents.
	// if we do need to update the contents, remove the listbox and start anew.
	if (hwnd.listbox>0)
		if (ArraySize(magics.save)>0)
			for (i=0;i<ArraySize(magics.save);i++)
				if (magics[i] != magics.save[i]){
					tbRemove(hwnd.chart,hwnd.listbox);
					hwnd.listbox=0;
					break;
				}
	
	if (hwnd.listbox==0){
		// create the object
		hwnd.listbox=tbPutObject(hwnd.chart,"list",-191,-43,150,20,"ChronusListbox");
		tbSetText(hwnd.chart,hwnd.listbox,CharToStr(SymbolNum),SymbolSize,8);
		
		// fill it up
		tbAddListItem(hwnd.chart,hwnd.listbox,"All Trades");
		tbAddListItem(hwnd.chart,hwnd.listbox,"Only with Magic");
		tbAddListItem(hwnd.chart,hwnd.listbox,"Only without Magic");
		tbAddListItem(hwnd.chart,hwnd.listbox,"------------------");
		tbAddListItem(hwnd.chart,hwnd.listbox,"Specific Magic:");
		for (i=0;i<ArraySize(magics);i++) tbAddListItem(hwnd.chart,hwnd.listbox,magics[i]);
		
		// carry over the previous selection (for recompile and timeframe changes only)
		if (GlobalVariableCheck("Chronus-list-content-on-init")==true){
			j=GlobalVariableGet("Chronus-list-content-on-init");
			GlobalVariableDel("Chronus-list-content-on-init");
		}
		if      (j==0)  { tbSetListSel(hwnd.chart,hwnd.listbox,0); } // default: all trades
		else if (j==-1) { tbSetListSel(hwnd.chart,hwnd.listbox,1); } 
		else if (j==-2) { tbSetListSel(hwnd.chart,hwnd.listbox,2); } 
		else            { tbSetListSel(hwnd.chart,hwnd.listbox,ArrayBsearch(magics,j)+5); }
	}
	
	
	// save the magics from last run for updating later
	ArrayResize(magics.save,ArraySize(magics));
	ArrayCopy(magics.save,magics);
	
	return (EXIT_SUCCESS);
}

